Index: XIOS/dev/branch_openmp/extern/remap/src/mapper.cpp
===================================================================
--- XIOS/dev/branch_openmp/extern/remap/src/mapper.cpp	(revision 1545)
+++ XIOS/dev/branch_openmp/extern/remap/src/mapper.cpp	(revision 1642)
@@ -716,225 +724,225 @@
 void Mapper::computeIntersection(Elt *elements, int nbElements)
 {
-	int mpiSize, mpiRank;
-	MPI_Comm_size(communicator, &mpiSize);
-	MPI_Comm_rank(communicator, &mpiRank);
-
-	MPI_Barrier(communicator);
-
-	vector<Node> *routingList = new vector<Node>[mpiSize];
-
-	vector<Node> routeNodes;  routeNodes.reserve(nbElements);
-	for (int j = 0; j < nbElements; j++)
-	{
-		elements[j].id.ind = j;
-		elements[j].id.rank = mpiRank;
-		routeNodes.push_back(Node(elements[j].x, cptRadius(elements[j]), &elements[j]));
-	}
-
-	vector<vector<int> > routes(routeNodes.size());
-	sstree.routeIntersections(routes, routeNodes);
-	for (int i = 0; i < routes.size(); ++i)
-		for (int k = 0; k < routes[i].size(); ++k)
-			routingList[routes[i][k]].push_back(routeNodes[i]);
-
-	if (verbose >= 2)
-	{
-		cout << " --> rank  " << mpiRank << " nbElements " << nbElements << " : ";
-		for (int rank = 0; rank < mpiSize; rank++)
-			cout << routingList[rank].size() << "   ";
-		cout << endl;
-	}
-	MPI_Barrier(communicator);
-
-	int *nbSendNode = new int[mpiSize];
-	int *nbRecvNode = new int[mpiSize];
-	int *sentMessageSize = new int[mpiSize];
-	int *recvMessageSize = new int[mpiSize];
-
-	for (int rank = 0; rank < mpiSize; rank++)
-	{
-		nbSendNode[rank] = routingList[rank].size();
-		sentMessageSize[rank] = 0;
-		for (size_t j = 0; j < routingList[rank].size(); j++)
-		{
-			Elt *elt = (Elt *) (routingList[rank][j].data);
-			sentMessageSize[rank] += packedPolygonSize(*elt);
-		}
-	}
-
-	MPI_Alltoall(nbSendNode, 1, MPI_INT, nbRecvNode, 1, MPI_INT, communicator);
-	MPI_Alltoall(sentMessageSize, 1, MPI_INT, recvMessageSize, 1, MPI_INT, communicator);
-
-	int total = 0;
-
-	for (int rank = 0; rank < mpiSize; rank++)
-	{
-		total = total + nbRecvNode[rank];
-	}
-
-	if (verbose >= 2) cout << "---> rank " << mpiRank << " : compute intersection : total received nodes  " << total << endl;
-	char **sendBuffer = new char*[mpiSize];
-	char **recvBuffer = new char*[mpiSize];
-	int *pos = new int[mpiSize];
-
-	for (int rank = 0; rank < mpiSize; rank++)
-	{
-		if (nbSendNode[rank] > 0) sendBuffer[rank] = new char[sentMessageSize[rank]];
-		if (nbRecvNode[rank] > 0) recvBuffer[rank] = new char[recvMessageSize[rank]];
-	}
-
-	for (int rank = 0; rank < mpiSize; rank++)
-	{
-		pos[rank] = 0;
-		for (size_t j = 0; j < routingList[rank].size(); j++)
-		{
-			Elt* elt = (Elt *) (routingList[rank][j].data);
-			packPolygon(*elt, sendBuffer[rank], pos[rank]);
-		}
-	}
-	delete [] routingList;
-
-	int nbSendRequest = 0;
-	int nbRecvRequest = 0;
-	MPI_Request *sendRequest = new MPI_Request[mpiSize];
-	MPI_Request *recvRequest = new MPI_Request[mpiSize];
-	MPI_Status   *status = new MPI_Status[mpiSize];
-
-	for (int rank = 0; rank < mpiSize; rank++)
-	{
-		if (nbSendNode[rank] > 0)
-		{
-			MPI_Issend(sendBuffer[rank], sentMessageSize[rank], MPI_CHAR, rank, 0, communicator, &sendRequest[nbSendRequest]);
-			nbSendRequest++;
-		}
-		if (nbRecvNode[rank] > 0)
-		{
-			MPI_Irecv(recvBuffer[rank], recvMessageSize[rank], MPI_CHAR, rank, 0, communicator, &recvRequest[nbRecvRequest]);
-			nbRecvRequest++;
-		}
-	}
-
-	MPI_Waitall(nbRecvRequest, recvRequest, status);
-	MPI_Waitall(nbSendRequest, sendRequest, status);
-	char **sendBuffer2 = new char*[mpiSize];
-	char **recvBuffer2 = new char*[mpiSize];
-
-	double tic = cputime();
-	for (int rank = 0; rank < mpiSize; rank++)
-	{
-		sentMessageSize[rank] = 0;
-
-		if (nbRecvNode[rank] > 0)
-		{
-			Elt *recvElt = new Elt[nbRecvNode[rank]];
-			pos[rank] = 0;
-			for (int j = 0; j < nbRecvNode[rank]; j++)
-			{
-				unpackPolygon(recvElt[j], recvBuffer[rank], pos[rank]);
-				cptEltGeom(recvElt[j], tgtGrid.pole);
-				Node recvNode(recvElt[j].x, cptRadius(recvElt[j]), &recvElt[j]);
-				recvNode.search(sstree.localTree.root);
-				/* for a node holding an element of the target, loop throught candidates for intersecting source */
-				for (list<NodePtr>::iterator it = (recvNode.intersectors).begin(); it != (recvNode.intersectors).end(); ++it)
-				{
-					Elt *elt2 = (Elt *) ((*it)->data);
-					/* recvElt is target, elt2 is source */
-//					intersect(&recvElt[j], elt2);
-					intersect_ym(&recvElt[j], elt2);
-				}
-
-				if (recvElt[j].is.size() > 0) sentMessageSize[rank] += packIntersectionSize(recvElt[j]);
-
-				// here recvNode goes out of scope
-			}
-
-			if (sentMessageSize[rank] > 0)
-			{
-				sentMessageSize[rank] += sizeof(int);
-				sendBuffer2[rank] = new char[sentMessageSize[rank]];
-				*((int *) sendBuffer2[rank]) = 0;
-				pos[rank] = sizeof(int);
-				for (int j = 0; j < nbRecvNode[rank]; j++)
-				{
-					packIntersection(recvElt[j], sendBuffer2[rank], pos[rank]);
-					//FIXME should be deleted: recvElt[j].delete_intersections(); // intersection areas have been packed to buffer and won't be used any more
-				}
-			}
-			delete [] recvElt;
-
-		}
-	}
-	delete [] pos;
-
-	for (int rank = 0; rank < mpiSize; rank++)
-	{
-		if (nbSendNode[rank] > 0) delete [] sendBuffer[rank];
-		if (nbRecvNode[rank] > 0) delete [] recvBuffer[rank];
-		nbSendNode[rank] = 0;
-	}
-
-	if (verbose >= 2) cout << "Rank " << mpiRank << "  Compute (internal) intersection " << cputime() - tic << " s" << endl;
-	MPI_Alltoall(sentMessageSize, 1, MPI_INT, recvMessageSize, 1, MPI_INT, communicator);
-
-	for (int rank = 0; rank < mpiSize; rank++)
-		if (recvMessageSize[rank] > 0)
-			recvBuffer2[rank] = new char[recvMessageSize[rank]];
-
-	nbSendRequest = 0;
-	nbRecvRequest = 0;
-
-	for (int rank = 0; rank < mpiSize; rank++)
-	{
-		if (sentMessageSize[rank] > 0)
-		{
-			MPI_Issend(sendBuffer2[rank], sentMessageSize[rank], MPI_CHAR, rank, 0, communicator, &sendRequest[nbSendRequest]);
-			nbSendRequest++;
-		}
-		if (recvMessageSize[rank] > 0)
-		{
-			MPI_Irecv(recvBuffer2[rank], recvMessageSize[rank], MPI_CHAR, rank, 0, communicator, &recvRequest[nbRecvRequest]);
-			nbRecvRequest++;
-		}
-	}
-
-	MPI_Waitall(nbRecvRequest, recvRequest, status);
-	MPI_Waitall(nbSendRequest, sendRequest, status);
-
-	delete [] sendRequest;
-	delete [] recvRequest;
-	delete [] status;
-	for (int rank = 0; rank < mpiSize; rank++)
-	{
-		if (nbRecvNode[rank] > 0)
-		{
-			if (sentMessageSize[rank] > 0)
-				delete [] sendBuffer2[rank];
-		}
-
-		if (recvMessageSize[rank] > 0)
-		{
-			unpackIntersection(elements, recvBuffer2[rank]);
-			delete [] recvBuffer2[rank];
-		}
-	}
-	delete [] sendBuffer2;
-	delete [] recvBuffer2;
-	delete [] sendBuffer;
-	delete [] recvBuffer;
-
-	delete [] nbSendNode;
-	delete [] nbRecvNode;
-	delete [] sentMessageSize;
-	delete [] recvMessageSize;
+  int mpiSize, mpiRank;
+  ep_lib::MPI_Comm_size(communicator, &mpiSize);
+  ep_lib::MPI_Comm_rank(communicator, &mpiRank);
+
+  ep_lib::MPI_Barrier(communicator);
+
+  vector<Node> *routingList = new vector<Node>[mpiSize];
+
+  vector<Node> routeNodes;  routeNodes.reserve(nbElements);
+  for (int j = 0; j < nbElements; j++)
+  {
+    elements[j].id.ind = j;
+    elements[j].id.rank = mpiRank;
+    routeNodes.push_back(Node(elements[j].x, cptRadius(elements[j]), &elements[j]));
+  }
+
+  vector<vector<int> > routes(routeNodes.size());
+  sstree.routeIntersections(routes, routeNodes);
+  for (int i = 0; i < routes.size(); ++i)
+    for (int k = 0; k < routes[i].size(); ++k)
+      routingList[routes[i][k]].push_back(routeNodes[i]);
+
+  if (verbose >= 2)
+  {
+    cout << " --> rank  " << mpiRank << " nbElements " << nbElements << " : ";
+    for (int rank = 0; rank < mpiSize; rank++)
+      cout << routingList[rank].size() << "   ";
+    cout << endl;
+  }
+  ep_lib::MPI_Barrier(communicator);
+
+  int *nbSendNode = new int[mpiSize];
+  int *nbRecvNode = new int[mpiSize];
+  int *sentMessageSize = new int[mpiSize];
+  int *recvMessageSize = new int[mpiSize];
+
+  for (int rank = 0; rank < mpiSize; rank++)
+  {
+    nbSendNode[rank] = routingList[rank].size();
+    sentMessageSize[rank] = 0;
+    for (size_t j = 0; j < routingList[rank].size(); j++)
+    {
+      Elt *elt = (Elt *) (routingList[rank][j].data);
+      sentMessageSize[rank] += packedPolygonSize(*elt);
+    }
+  }
+
+  ep_lib::MPI_Alltoall(nbSendNode, 1, EP_INT, nbRecvNode, 1, EP_INT, communicator);
+  ep_lib::MPI_Alltoall(sentMessageSize, 1, EP_INT, recvMessageSize, 1, EP_INT, communicator);
+
+  int total = 0;
+
+  for (int rank = 0; rank < mpiSize; rank++)
+  {
+    total = total + nbRecvNode[rank];
+  }
+
+  if (verbose >= 2) cout << "---> rank " << mpiRank << " : compute intersection : total received nodes  " << total << endl;
+  char **sendBuffer = new char*[mpiSize];
+  char **recvBuffer = new char*[mpiSize];
+  int *pos = new int[mpiSize];
+
+  for (int rank = 0; rank < mpiSize; rank++)
+  {
+    if (nbSendNode[rank] > 0) sendBuffer[rank] = new char[sentMessageSize[rank]];
+    if (nbRecvNode[rank] > 0) recvBuffer[rank] = new char[recvMessageSize[rank]];
+  }
+
+  for (int rank = 0; rank < mpiSize; rank++)
+  {
+    pos[rank] = 0;
+    for (size_t j = 0; j < routingList[rank].size(); j++)
+    {
+      Elt* elt = (Elt *) (routingList[rank][j].data);
+      packPolygon(*elt, sendBuffer[rank], pos[rank]);
+    }
+  }
+  delete [] routingList;
+
+  int nbSendRequest = 0;
+  int nbRecvRequest = 0;
+  ep_lib::MPI_Request *sendRequest = new ep_lib::MPI_Request[mpiSize];
+  ep_lib::MPI_Request *recvRequest = new ep_lib::MPI_Request[mpiSize];
+  ep_lib::MPI_Status   *status = new ep_lib::MPI_Status[mpiSize];
+
+  for (int rank = 0; rank < mpiSize; rank++)
+  {
+    if (nbSendNode[rank] > 0)
+    {
+      ep_lib::MPI_Issend(sendBuffer[rank], sentMessageSize[rank], EP_CHAR, rank, 0, communicator, &sendRequest[nbSendRequest]);
+      nbSendRequest++;
+    }
+    if (nbRecvNode[rank] > 0)
+    {
+      ep_lib::MPI_Irecv(recvBuffer[rank], recvMessageSize[rank], EP_CHAR, rank, 0, communicator, &recvRequest[nbRecvRequest]);
+      nbRecvRequest++;
+    }
+  }
+
+  ep_lib::MPI_Waitall(nbRecvRequest, recvRequest, status);
+  ep_lib::MPI_Waitall(nbSendRequest, sendRequest, status);
+  char **sendBuffer2 = new char*[mpiSize];
+  char **recvBuffer2 = new char*[mpiSize];
+
+  double tic = cputime();
+  for (int rank = 0; rank < mpiSize; rank++)
+  {
+    sentMessageSize[rank] = 0;
+
+    if (nbRecvNode[rank] > 0)
+    {
+      Elt *recvElt = new Elt[nbRecvNode[rank]];
+      pos[rank] = 0;
+      for (int j = 0; j < nbRecvNode[rank]; j++)
+      {
+        unpackPolygon(recvElt[j], recvBuffer[rank], pos[rank]);
+        cptEltGeom(recvElt[j], tgtGrid.pole);
+        Node recvNode(recvElt[j].x, cptRadius(recvElt[j]), &recvElt[j]);
+        recvNode.search(sstree.localTree.root);
+        /* for a node holding an element of the target, loop throught candidates for intersecting source */
+        for (list<NodePtr>::iterator it = (recvNode.intersectors).begin(); it != (recvNode.intersectors).end(); ++it)
+        {
+          Elt *elt2 = (Elt *) ((*it)->data);
+          /* recvElt is target, elt2 is source */
+//          intersect(&recvElt[j], elt2);
+          intersect_ym(&recvElt[j], elt2);
+        }
+
+        if (recvElt[j].is.size() > 0) sentMessageSize[rank] += packIntersectionSize(recvElt[j]);
+
+        // here recvNode goes out of scope
+      }
+
+      if (sentMessageSize[rank] > 0)
+      {
+        sentMessageSize[rank] += sizeof(int);
+        sendBuffer2[rank] = new char[sentMessageSize[rank]];
+        *((int *) sendBuffer2[rank]) = 0;
+        pos[rank] = sizeof(int);
+        for (int j = 0; j < nbRecvNode[rank]; j++)
+        {
+          packIntersection(recvElt[j], sendBuffer2[rank], pos[rank]);
+          //FIXME should be deleted: recvElt[j].delete_intersections(); // intersection areas have been packed to buffer and won't be used any more
+        }
+      }
+      delete [] recvElt;
+
+    }
+  }
+  delete [] pos;
+
+  for (int rank = 0; rank < mpiSize; rank++)
+  {
+    if (nbSendNode[rank] > 0) delete [] sendBuffer[rank];
+    if (nbRecvNode[rank] > 0) delete [] recvBuffer[rank];
+    nbSendNode[rank] = 0;
+  }
+
+  if (verbose >= 2) cout << "Rank " << mpiRank << "  Compute (internal) intersection " << cputime() - tic << " s" << endl;
+  ep_lib::MPI_Alltoall(sentMessageSize, 1, EP_INT, recvMessageSize, 1, EP_INT, communicator);
+
+  for (int rank = 0; rank < mpiSize; rank++)
+    if (recvMessageSize[rank] > 0)
+      recvBuffer2[rank] = new char[recvMessageSize[rank]];
+
+  nbSendRequest = 0;
+  nbRecvRequest = 0;
+
+  for (int rank = 0; rank < mpiSize; rank++)
+  {
+    if (sentMessageSize[rank] > 0)
+    {
+      ep_lib::MPI_Issend(sendBuffer2[rank], sentMessageSize[rank], EP_CHAR, rank, 0, communicator, &sendRequest[nbSendRequest]);
+      nbSendRequest++;
+    }
+    if (recvMessageSize[rank] > 0)
+    {
+      ep_lib::MPI_Irecv(recvBuffer2[rank], recvMessageSize[rank], EP_CHAR, rank, 0, communicator, &recvRequest[nbRecvRequest]);
+      nbRecvRequest++;
+    }
+  }
+
+  ep_lib::MPI_Waitall(nbRecvRequest, recvRequest, status);
+  ep_lib::MPI_Waitall(nbSendRequest, sendRequest, status);
+
+  delete [] sendRequest;
+  delete [] recvRequest;
+  delete [] status;
+  for (int rank = 0; rank < mpiSize; rank++)
+  {
+    if (nbRecvNode[rank] > 0)
+    {
+      if (sentMessageSize[rank] > 0)
+        delete [] sendBuffer2[rank];
+    }
+
+    if (recvMessageSize[rank] > 0)
+    {
+      unpackIntersection(elements, recvBuffer2[rank]);
+      delete [] recvBuffer2[rank];
+    }
+  }
+  delete [] sendBuffer2;
+  delete [] recvBuffer2;
+  delete [] sendBuffer;
+  delete [] recvBuffer;
+
+  delete [] nbSendNode;
+  delete [] nbRecvNode;
+  delete [] sentMessageSize;
+  delete [] recvMessageSize;
 }
 
 Mapper::~Mapper()
 {
-	delete [] remapMatrix;
-	delete [] srcAddress;
-	delete [] srcRank;
-	delete [] dstAddress;
-	if (neighbourElements) delete [] neighbourElements;
-}
-
-}
+  delete [] remapMatrix;
+  delete [] srcAddress;
+  delete [] srcRank;
+  delete [] dstAddress;
+  if (neighbourElements) delete [] neighbourElements;
+}
+
+}
Index: XIOS/dev/branch_openmp/extern/remap/src/mapper.hpp
===================================================================
--- XIOS/dev/branch_openmp/extern/remap/src/mapper.hpp	(revision 1545)
+++ XIOS/dev/branch_openmp/extern/remap/src/mapper.hpp	(revision 1642)
@@ -18,11 +18,10 @@
 {
 public:
-       Mapper(ep_lib::MPI_Comm comm) : communicator(comm), verbose(SILENT), neighbourElements(NULL), sstree(comm) {}
-
+       Mapper(ep_lib::MPI_Comm comm=EP_COMM_WORLD) : communicator(comm), verbose(SILENT), neighbourElements(NULL), sstree(comm) {}
        ~Mapper();
        void setVerbosity(verbosity v) {verbose=v ;}
 
-       void setSourceMesh(const double* boundsLon, const double* boundsLat, int nVertex, int nbCells, const double* pole, const long int* globalId=NULL) ;
-       void setTargetMesh(const double* boundsLon, const double* boundsLat, int nVertex, int nbCells, const double* pole, const long int* globalId=NULL) ;
+       void setSourceMesh(const double* boundsLon, const double* boundsLat, const double* area, int nVertex, int nbCells, const double* pole, const long int* globalId=NULL) ;
+       void setTargetMesh(const double* boundsLon, const double* boundsLat, const double* area, int nVertex, int nbCells, const double* pole, const long int* globalId=NULL) ;
        void setSourceValue(const double* val) ;
        void getTargetValue(double* val) ;
Index: XIOS/dev/branch_openmp/extern/remap/src/meshutil.cpp
===================================================================
--- XIOS/dev/branch_openmp/extern/remap/src/meshutil.cpp	(revision 1545)
+++ XIOS/dev/branch_openmp/extern/remap/src/meshutil.cpp	(revision 1642)
@@ -2,8 +2,65 @@
 #include "elt.hpp"
 #include "polyg.hpp"
+#include "intersection_ym.hpp"
+#include "earcut.hpp"
+#include <vector>
 
 namespace sphereRemap {
 
 using namespace std;
+
+double computePolygoneArea(Elt& a, const Coord &pole)
+{
+  using N = uint32_t;
+  using Point = array<double, 2>;
+  vector<Point> vect_points;
+  vector< vector<Point> > polyline;
+  
+  vector<Coord> dstPolygon ;
+  createGreatCirclePolygon(a, pole, dstPolygon) ;
+
+  int na=dstPolygon.size() ;
+  Coord *a_gno   = new Coord[na];
+  
+  Coord OC=barycentre(a.vertex,a.n) ;
+  Coord Oz=OC ;
+  Coord Ox=crossprod(Coord(0,0,1),Oz) ;
+// choose Ox not too small to avoid rounding error
+  if (norm(Ox)< 0.1) Ox=crossprod(Coord(0,1,0),Oz) ;
+  Ox=Ox*(1./norm(Ox)) ;
+  Coord Oy=crossprod(Oz,Ox) ;
+  double cos_alpha;
+
+  for(int n=0; n<na;n++)
+  {
+    cos_alpha=scalarprod(OC,dstPolygon[n]) ;
+    a_gno[n].x=scalarprod(dstPolygon[n],Ox)/cos_alpha ;
+    a_gno[n].y=scalarprod(dstPolygon[n],Oy)/cos_alpha ;
+    a_gno[n].z=scalarprod(dstPolygon[n],Oz)/cos_alpha ; // must be equal to 1
+
+    vect_points.push_back( array<double, 2>() );
+    vect_points[n][0] = a_gno[n].x;
+    vect_points[n][1] = a_gno[n].y;
+
+  }
+
+  polyline.push_back(vect_points);
+  vector<N> indices_a_gno = mapbox::earcut<N>(polyline);
+  
+  double area_a_gno=0 ;
+  for(int i=0;i<indices_a_gno.size()/3;++i)
+    {
+      Coord x0 = Ox * polyline[0][indices_a_gno[3*i]][0] + Oy* polyline[0][indices_a_gno[3*i]][1] + Oz ;
+      Coord x1 = Ox * polyline[0][indices_a_gno[3*i+1]][0] + Oy* polyline[0][indices_a_gno[3*i+1]][1] + Oz ;
+      Coord x2 = Ox * polyline[0][indices_a_gno[3*i+2]][0] + Oy* polyline[0][indices_a_gno[3*i+2]][1] + Oz ;
+      area_a_gno+=triarea(x0 * (1./norm(x0)),x1* (1./norm(x1)), x2* (1./norm(x2))) ;
+    }
+
+  vect_points.clear();
+  polyline.clear();
+  indices_a_gno.clear();
+  return area_a_gno ;
+}
+
 
 void cptEltGeom(Elt& elt, const Coord &pole)
@@ -14,5 +71,9 @@
   elt.area = airbar(elt.n, elt.vertex, elt.edge, elt.d, pole, gg);
   elt.x = gg;
-}
+// overwrite area computation 
+
+  elt.area =  computePolygoneArea(elt, pole) ;
+}
+
 
 void cptAllEltsGeom(Elt *elt, int N, const Coord &pole)
@@ -133,5 +194,6 @@
   {
     for (int i = 0; i < elts[j]->n; i++) 
-      if ( elts[j]->neighbour[i]== NOT_FOUND) neighbours[i]=NULL ;
+      if ( elts[j]->neighbour[i]== NOT_FOUND) neighbours[i]=NULL ; // no neighbour
+      else if (elts[elts[j]->neighbour[i]]->is.size() == 0) neighbours[i]=NULL ; // neighbour has none supermesh cell 
       else  neighbours[i] = elts[elts[j]->neighbour[i]];
 
Index: XIOS/dev/branch_openmp/extern/remap/src/mpi_cascade.cpp
===================================================================
--- XIOS/dev/branch_openmp/extern/remap/src/mpi_cascade.cpp	(revision 1545)
+++ XIOS/dev/branch_openmp/extern/remap/src/mpi_cascade.cpp	(revision 1642)
@@ -1,12 +1,11 @@
 #include "mpi_cascade.hpp"
 #include <iostream>
-using namespace ep_lib;
 
 namespace sphereRemap {
 
-CMPICascade::CMPICascade(int nodes_per_level, MPI_Comm comm)
+CMPICascade::CMPICascade(int nodes_per_level, ep_lib::MPI_Comm comm)
 {
 	int remaining_levels;
-	MPI_Comm intraComm;
+	ep_lib::MPI_Comm intraComm;
 	int l = 0; // current level
 	do {
@@ -16,6 +15,6 @@
 		level[l].p_grp_size = level[l].size/level[l].group_size;
 	
-		MPI_Comm_split(comm, level[l].colour(), level[l].key(), &intraComm);
-		MPI_Comm_split(comm, level[l].p_colour(), level[l].p_key(), &(level[l].pg_comm));
+		ep_lib::MPI_Comm_split(comm, level[l].colour(), level[l].key(), &intraComm);
+		ep_lib::MPI_Comm_split(comm, level[l].p_colour(), level[l].p_key(), &(level[l].pg_comm));
 		comm = intraComm;
 		l++;
Index: XIOS/dev/branch_openmp/extern/remap/src/mpi_cascade.hpp
===================================================================
--- XIOS/dev/branch_openmp/extern/remap/src/mpi_cascade.hpp	(revision 1545)
+++ XIOS/dev/branch_openmp/extern/remap/src/mpi_cascade.hpp	(revision 1642)
@@ -12,21 +12,21 @@
 {
 public:
-  CCascadeLevel(ep_lib::MPI_Comm comm) : comm(comm)
-  {
-    ep_lib::MPI_Comm_size(comm, &size);
-    ep_lib::MPI_Comm_rank(comm, &rank);
-  }
-  int colour() const { return rank % group_size; };
-  int key() const { return p_colour() + rank/(p_grp_size*group_size)*p_grp_size; }
+	CCascadeLevel(ep_lib::MPI_Comm comm) : comm(comm)
+	{
+		ep_lib::MPI_Comm_size(comm, &size);
+		ep_lib::MPI_Comm_rank(comm, &rank);
+	}
+	int colour() const { return rank % group_size; };
+	int key() const { return p_colour() + rank/(p_grp_size*group_size)*p_grp_size; }
 
-  // perpendicular group
-  int p_colour() const { return (rank%group_size + rank/group_size) % p_grp_size; }
-  int p_key() const { return colour() + rank/(p_grp_size*group_size)*group_size; }
+	// perpendicular group
+	int p_colour() const { return (rank%group_size + rank/group_size) % p_grp_size; }
+	int p_key() const { return colour() + rank/(p_grp_size*group_size)*group_size; }
 
-  ep_lib::MPI_Comm comm, pg_comm;
-  int rank;
-  int size;
-  int group_size; // group_size and p_grp_size are interchanged?? FIXME
-  int p_grp_size;
+	ep_lib::MPI_Comm comm, pg_comm;
+	int rank;
+	int size;
+	int group_size; // group_size and p_grp_size are interchanged?? FIXME
+	int p_grp_size;
 };
 
@@ -34,8 +34,9 @@
 {
 public:
-  CMPICascade(int nodes_per_level, ep_lib::MPI_Comm comm);
+	// 
+	CMPICascade(int nodes_per_level, ep_lib::MPI_Comm comm);
 
-  int num_levels;
-  std::vector<CCascadeLevel> level;
+	int num_levels;
+	std::vector<CCascadeLevel> level;
 };
 
